var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import { oneOf, bool, number } from 'prop-types';
import styled from '../styled';
import React from 'react';

var Flex = styled(function (theme, _ref) {
  var justify = _ref.justify,
      column = _ref.column,
      center = _ref.center,
      order = _ref.order,
      align = _ref.align,
      wrap = _ref.wrap,
      props = _objectWithoutProperties(_ref, ['justify', 'column', 'center', 'order', 'align', 'wrap']);

  return {
    props: props,
    css: _extends({
      display: 'flex',
      alignItems: align,
      justifyContent: justify,
      flexWrap: wrap ? 'wrap' : null,
      flexDirection: column ? 'column' : null,
      order: order

    }, center ? {
      alignItems: 'center',
      justifyContent: 'center'
    } : {})
  };
});

Flex.PropTypes = {
  align: oneOf(['flex-start', 'flex-end', 'baseline', 'center', 'stretch']),

  justify: oneOf(['flex-start', 'flex-end', 'center', 'space-between', 'space-around']),

  order: number,
  column: bool,
  wrap: bool
};

export default Flex;