var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import context from './context';
import isFunction from '@f/is-function';
import React from 'react';

import { removeProps, fontSize, space, width, color } from 'styled-system';

import { combineRules } from 'fela';

var styled = function styled() {
  var BaseComponent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'div';
  var createComponent = arguments[1];

  if (isFunction(BaseComponent)) {
    createComponent = BaseComponent;
    BaseComponent = 'div';
  }

  var VeelComponent = function VeelComponent(_ref, ctx) {
    var is = _ref.is,
        css = _ref.css,
        props = _objectWithoutProperties(_ref, ['is', 'css']);

    var _ctx$context$ns = ctx[context.ns],
        renderer = _ctx$context$ns.renderer,
        theme = _ctx$context$ns.theme;


    var style = createComponent ? createComponent(theme, props) : { props: props };

    var cn = renderer.renderRule(combineRules(fontSize, space, width, color, function () {
      return _extends({}, style.css, css);
    }), props);

    var Component = is || BaseComponent;

    return React.createElement(Component, _extends({
      className: cn
    }, removeProps(style.props)));
  };

  VeelComponent.contextTypes = context.types;
  return VeelComponent;
};

export default styled;