'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _styled = require('../styled');

var _styled2 = _interopRequireDefault(_styled);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Flex = (0, _styled2.default)(function (theme, _ref) {
  var justify = _ref.justify,
      column = _ref.column,
      center = _ref.center,
      order = _ref.order,
      align = _ref.align,
      wrap = _ref.wrap,
      props = _objectWithoutProperties(_ref, ['justify', 'column', 'center', 'order', 'align', 'wrap']);

  return {
    props: props,
    css: _extends({
      display: 'flex',
      alignItems: align,
      justifyContent: justify,
      flexWrap: wrap ? 'wrap' : null,
      flexDirection: column ? 'column' : null,
      order: order

    }, center ? {
      alignItems: 'center',
      justifyContent: 'center'
    } : {})
  };
});

Flex.PropTypes = {
  align: (0, _propTypes.oneOf)(['flex-start', 'flex-end', 'baseline', 'center', 'stretch']),

  justify: (0, _propTypes.oneOf)(['flex-start', 'flex-end', 'center', 'space-between', 'space-around']),

  order: _propTypes.number,
  column: _propTypes.bool,
  wrap: _propTypes.bool
};

exports.default = Flex;
module.exports = exports['default'];