'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

var _isFunction = require('@f/is-function');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledSystem = require('styled-system');

var _fela = require('fela');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var styled = function styled() {
  var BaseComponent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'div';
  var createComponent = arguments[1];

  if ((0, _isFunction2.default)(BaseComponent)) {
    createComponent = BaseComponent;
    BaseComponent = 'div';
  }

  var VeelComponent = function VeelComponent(_ref, ctx) {
    var is = _ref.is,
        css = _ref.css,
        props = _objectWithoutProperties(_ref, ['is', 'css']);

    var _ctx$context$ns = ctx[_context2.default.ns],
        renderer = _ctx$context$ns.renderer,
        theme = _ctx$context$ns.theme;


    var style = createComponent ? createComponent(theme, props) : { props: props };

    var cn = renderer.renderRule((0, _fela.combineRules)(_styledSystem.fontSize, _styledSystem.space, _styledSystem.width, _styledSystem.color, function () {
      return _extends({}, style.css, css);
    }), props);

    var Component = is || BaseComponent;

    return _react2.default.createElement(Component, _extends({
      className: cn
    }, (0, _styledSystem.removeProps)(style.props)));
  };

  VeelComponent.contextTypes = _context2.default.types;
  return VeelComponent;
};

exports.default = styled;
module.exports = exports['default'];